//variables for shortcuts to html elements
const preferencesService    = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService ).getBranch( "folkd.");
var sidebardoc     		= false;
var transport_out  		= false;
var transport_in   		= false;
var transport_user 		= false;
var transport_pw   		= false;
var transport_lang 		= false;
var transport_version	= false;
var busyimage      		= false;

//
var last_sent_url  		= false;
var fx_mainWindow;
var alive = true;

//**************************************************************************
//initialisation of our nice application
function load_startup_page(event) {
	
	//get global variables for some html elements document
	sidebardoc      	= document.getElementById('folkd-contents').contentDocument;
    busyimage       	= document.getElementById("busy");
	transport_out   	= sidebardoc.getElementById('var_browser_to_folkd');
	transport_in    	= sidebardoc.getElementById('var_folkd_to_browser');
	transport_title 	= sidebardoc.getElementById('var_browser_to_folkd_title');
	transport_user  	= sidebardoc.getElementById('var_folkd_username');
	transport_pw    	= sidebardoc.getElementById('var_folkd_password');
	transport_lang  	= sidebardoc.getElementById('var_folkd_language');
	transport_version	= sidebardoc.getElementById('var_folkd_version'); 
	
	//add browser listeners
	folkdShared.get_navigator().addEventListener( 'DOMAttrModified', browser_listener, true );

	//set username and password transport field
	transport_user.value    = preferencesService.getCharPref('settings.username');
	transport_pw.value      = preferencesService.getCharPref('settings.password');
	transport_lang.value    = preferencesService.getCharPref('settings.userlanguage');
	transport_version.value = document.getElementById('version').value;
	
	//add transport field listener
	addEvent( sidebardoc, "folkd_to_browser_event", folkd_listener   );
	addEvent( sidebardoc, "store_user_and_password", store_userpw    );
	addEvent( sidebardoc, "busy_off_event",         busy_off         );
	addEvent( sidebardoc, "busy_on_event",          busy_on          );

	try { transport_out.value   = folkdShared.get_content_browser().contentWindow.location.href; } catch(ex){}
	transport_title.value = folkdShared.get_content_browser().contentTitle;

	fireEvent("folkd_initialized", sidebardoc);
	busy_off();
}

//**************************************************************************
//cleanup activities
function destroy_application(event)
{
    alive=false;
	//remove browser listeners
	folkdShared.get_navigator().removeEventListener( 'DOMAttrModified', browser_listener, true );
}


//**************************************************************************
//function to write browser url changes to the transport field
function browser_listener() {
    if( typeof alive == "undefined" ) return;
	try { var newurl   = folkdShared.get_content_browser().selectedBrowser.contentWindow.location.href; } catch(ex){}
    
	if( typeof alive == "undefined" ) return;
	var newtitle = folkdShared.get_content_browser().selectedBrowser.contentTitle;
	if( last_sent_url != newurl ) {
		transport_out.value   = newurl;
		transport_title.value = newtitle;
		fireEvent("browser_to_folkd_event", sidebardoc);
		last_sent_url = newurl;
	}
}


//**************************************************************************
//function to execute something when url in folkd transport field changes
function folkd_listener() {
	//alert( "LOCAL: listener hit." );
	if( transport_in && (transport_in.value!="") ) {
		var newtab = folkdShared.get_content_browser().addTab( transport_in.value );
		folkdShared.get_content_browser().selectedTab = newtab;
		transport_in.value = "";
	}		
}

//**************************************************************************
//function to load a new page
function trigger_tab(url) {
	//alert( "LOCAL: listener hit." );
	if( url ) {
		var newtab = folkdShared.get_content_browser().addTab( url );
		folkdShared.get_content_browser().selectedTab = newtab;
	}		
}

//**************************************************************************
//switch "loading" indicator on
function busy_on() {
	busyimage.setAttribute("src", "chrome://folkd/skin/busy.gif");
}


//**************************************************************************
//switch "loading" indicator off
function busy_off() {
	busyimage.setAttribute("src", "chrome://folkd/skin/busybg.gif");
}


//**************************************************************************
//helper function for browser independet registration of object listeners
function addEvent( obj, type, fn )
{
	if (obj.addEventListener)
		obj.addEventListener( type, fn, false );
	else if (obj.attachEvent)
	{
		obj["e"+type+fn] = fn;
		obj.attachEvent( "on"+type, function() { obj["e"+type+fn](); } );
	}
}


//**************************************************************************
//helper function for browser independet removal of object listeners
function removeEvent( obj, type, fn )
{
	if (obj.removeEventListener)
		obj.removeEventListener( type, fn, false );
	else if (obj.detachEvent)
	{
		obj.detachEvent( "on"+type, obj["e"+type+fn] );
		obj["e"+type+fn] = null;
	}
}

//**************************************************************************
//browser independet helper function to trigger events
function fireEvent( name, target ) {
    if( target.createEvent ) {
        var evt = target.createEvent( "Events" );
        evt.initEvent( name, true, true );
        target.dispatchEvent( evt );
    } else if( target.createEventObject ) {
        var evt = target.createEventObject();
        target.fireEvent('on' + name, evt);
    }
}
//**************************************************************************
//browser independet helper function to trigger events
function store_userpw() {
	var online_username = sidebardoc.getElementById( "username" ).value	;
	var online_password = sidebardoc.getElementById( "password" ).value	;
	if ((online_username.length >1) && (online_password.length >1)) {
		preferencesService.setCharPref( "settings.username", online_username );
		preferencesService.setCharPref( "settings.password", hex_md5(online_password) );
	}
}
