try {
	const preferencesService  	= Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService ).getBranch( "folkd." );
	ShowOnStart					= preferencesService.getBoolPref( 'settings.showonstart' );
	InstallButtonsOnStart		= preferencesService.getBoolPref( 'settings.installbuttonsonstart' );
	orient 						= preferencesService.getCharPref( 'settings.orient' );
	showstatusbar				= preferencesService.getBoolPref( 'settings.showstatusbar' );
} catch (e) {
	ShowOnStart					= true;
	InstallButtonsOnStart		= true;
	orient 						= "ltr";
	showstatusbar				= true;
}

const WWW_PATH					= "http://www.folkd.com";
const INTERFACE_PATH			= "http://i.folkd.com/firefox";

var folkdMain = {
	last_url : false,
	do_refresh : false,
	startFolkd : function() {
		try {
			folkdMain.displaySideBarOnStartUp();
			folkdMain.setToolbarButton();
			folkdMain.showHideStatusbar();
		} catch (e) {
		}
	},	
	displaySideBarOnStartUp : function() {
	    if(ShowOnStart){
	    	folkdMain.showSideBar();
	    }
	},	
	showSideBar : function() {
		toggleSidebar("viewFolkdSidebar",true);
	},	
	setToolbarButton : function() { 
		if (InstallButtonsOnStart) {
			var nav   = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
			if (!nav) nav = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("emusic:window");
      nav = nav.document
			var navToolbar = nav.getElementById("nav-bar");
			var currentset = navToolbar.currentSet;
			var changed = false;
			if (navToolbar.currentSet.indexOf("save-it-button") == -1) {
				navToolbar.insertItem("save-it-button", nav.getElementById("urlbar-container"), null, false);	
				changed = true;
			}
			if (navToolbar.currentSet.indexOf("folkd-button") == -1) {
				navToolbar.insertItem("folkd-button", nav.getElementById("urlbar-container"), null, false);
				changed = true;
			}	
			if (changed) {
				nav.persist("nav-bar","currentset"); 
			}
		}
	},	
	showHideStatusbar : function() {
		if (!showstatusbar) {
			var nav   = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
			if (!nav) nav = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("emusic:window");
      nav = nav.document
			nav.getElementById('folkd-statusbar').setAttribute('hidden', true);
		}
	},	
	openSaveIt : function() {
		var url = '';
		try { var url = folkdShared.get_content_browser().selectedBrowser.contentWindow.location.href; } catch(ex){}
		var title = folkdShared.get_content_browser().selectedBrowser.contentTitle;
		openDialog(INTERFACE_PATH+'/add.php?page_url='+encodeURIComponent(url)+'&page_title=' +encodeURIComponent(title), 'addwin', 'width=550, height=540, left=100, top=100');		
	},
	refreshStatusbar : function (url, useLoginAndPW) {
		var upw = '';
		if (useLoginAndPW) {
			upw = "&u="+encodeURIComponent(preferencesService.getCharPref('settings.username'))+'&p='+encodeURIComponent(preferencesService.getCharPref('settings.password'))+"&lang="+encodeURIComponent(preferencesService.getCharPref('settings.userlanguage'))+"&client_version="+encodeURIComponent(preferencesService.getCharPref('settings.version'));

		}
		fullUrl = INTERFACE_PATH+'/tab_catch.php?statusbar=1' + upw+ '&url=' + encodeURIComponent(url);
	    var httpRequest = null;
		httpRequest = new XMLHttpRequest();
		httpRequest.open("GET", fullUrl, true);
	    httpRequest.onload = function() {
	    	var output = httpRequest.responseText;
	    	if (output.length)
		       {
		       	 if (output.substr(0,1)=='-' && useLoginAndPW==false) {
		       	 	folkdMain.refreshStatusbar(url,1);
		       	 } else {
		       	 	var nav   = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
							if (!nav) nav = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("emusic:window");
				      nav = nav.document
		         	nav.getElementById('folkd-statusbar').label = output;	         
		       	 }
		       }
	    }
	    httpRequest.send(null);
	},
	BrowserListener : function () {
		var newurl   = '';
		var nav   = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
  	if (!nav) nav = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("emusic:window");
		nav = nav.document
		try { var newurl   = folkdShared.get_content_browser().selectedBrowser.contentWindow.location.href; } catch(ex){}
	    if( (this.last_url != newurl) && (newurl.substr(0,7)=="http://") && (nav.getElementById('folkd-statusbar').hidden == false)) {
	    	nav.getElementById('folkd-statusbar').label = '...update...';
	    	this.last_url = newurl;
	    	window.clearTimeout(this.do_refresh);
			this.do_refresh = window.setTimeout(function(){folkdMain.refreshStatusbar(newurl,0);},750);
		}		
	}
}


window.addEventListener('load', folkdMain.startFolkd, false);
window.addEventListener('DOMAttrModified', folkdMain.BrowserListener, true );

// Position sidebar // no access to "document" within the folkdMain function
document.getElementById("browser").setAttribute( 'style', 'direction:'+orient);